{$M $400,0,0 }   { 1K stack, no heap }

{ THIS SOFTWARE AND SOURCE MAY BE MODIFIED TO SUIT YOUR NEEDS!  Everything
  may be distributed, sold, placed on any media as long as credits are given
  to where it's due (to the author, which is me, Animadei[T]).

  Since my *bad* monitor died, I've gotten a new monitor that actually has
  the brightness and contrast buttons.  It was sudden, but subtle, when I
  stopped this project, so I am releasing this source to those who really
  need it.

  Hope this source can inspire some talented programmers out there.  This is
  my first time looking at VGA programming.  Never done VGA before, probably
  never will.  Took me around 10-11 hours to get all this together, not real
  optimized, so don't expect too much!

  System requirement:  80386+ PC/AT etc. (has 386 "mov dword")
                       VGA monitor (will only work for 256 and below)        }



uses TSR_HU,Crt;


Type PaletteType = Array[0..767] of Byte;

var Int_9_Active: Boolean;
    T,SavedPal,P1,P2: PaletteType;
    i,i2,e,e2: Byte;
    KeepIntensity: Boolean;
    x: Word;



procedure VRetrace; assembler; asm {Vertical retrace}
  mov dx,$3DA; @VRetrace:; in al,dx; test al,8; jz @VRetrace; end;

procedure SetPalette (var PalBuf: PaletteType); assembler; asm
  push ds; lds si,PalBuf; mov dx,$3C8; mov cx,768; xor ax,ax; out dx,al;
  inc dx; cld; rep outsb; pop ds; end;

procedure GetPalette (var PalBuf: PaletteType); assembler; asm
  push es; les di,PalBuf; mov dx,$3C7; xor ax,ax; out dx,al; inc dx; inc dx;
  mov cx,768; cld; rep insb; pop es; end;

function CompPal (var a,b): Boolean; assembler; asm
  push ds; push es; lds si,a; les di,b; xor ax,ax; mov cx,768/4; cld; db $66;
  rep cmpsw; jc @Diff; or cx,cx; jnz @Diff; inc ax; @Diff:; pop es; pop ds; end;

procedure MovePal (var a,b); assembler; asm
  push ds; push es; lds si,a; les di,b; mov cx,768/4; cld; db $66; rep movsw;
  pop es; pop ds; end;

procedure Beep (x: Word); begin Sound(x); Delay(155); NoSound; end;



procedure Sub_Main;
begin
  asm
    CLI
  end;
    TSR.temp_SS := SSeg;     { Save the current stack }
    TSR.temp_SP := SPtr;
  asm;
    MOV SS,TSR.Our_SS        { Switch to our own stack! }
    MOV SP,TSR.Our_SP
    STI
  end;

  {---- START ----}

  { Automatic check for changes in the palette: update when necessary }
  GetPalette(T);
  if (CompPal(T,P2) = False) and (CompPal(T,P1) = False) then begin
    for x:=0 to 255 do
      if (T[x*3] = P2[x*3]) and
         (T[x*3+1] = P2[x*3+1]) and
         (T[x*3+2] = P2[x*3+2]) then begin
        T[x*3] := P1[x*3];
        T[x*3+1] := P1[x*3+1];
        T[x*3+2] := P1[x*3+2];
      end;
    MovePal(T,P1);
    SetPalette(P1);
  end;


  { Input keys corresponding to the functions }
  case Port[$60] of
    88: if i < 32 then Inc(i);
    87: if i > 1 then Dec(i);
    68: i := 32;
    67: begin
          KeepIntensity := Not KeepIntensity;
          if KeepIntensity then Beep(600)
                           else Beep(300);
        end;
    66: begin
          MovePal(SavedPal,P1);
          i := 32;
        end;
    65: MovePal(P1,SavedPal);
  end;

  { Update to correct colors' intensities }
  e := (32-i) shl 1;
  for x:=0 to 767 do P2[x] := ((P1[x]*i) shr 5)+e;
  VRetrace;
  SetPalette(P2);


  { Flush out keys; prevent key lock ups; prevent key buffer becoming full }
  if Keypressed then Readkey;

  {----  END  ----}

  asm
    CLI
    mov ss,TSR.temp_SS       { Restore original stack in memory! }
    mov sp,TSR.temp_SP
    STI
  end;
end;

procedure Main; interrupt;
begin
  { Key input commands etc. }
  if (Port[$60] in [88,87,68,67,66,65])
     and not Int_9_Active then begin { Main procedure }
    Int_9_Active := true;   { Tell the TSR that we are Active so that }
                            { we won't go into a hazardous loop! }
    { Reset keyboard to regain control of the keys }
    Port[$61] := Port[$61] or $80;      { reset keyboard }
    Port[$61] := Port[$61] and not $80;
    Port[$20] := $20;                   { signal end of interrupt }

    Sub_Main;               { The main entry to the program }
    Int_9_Active := false;  { Tell the TSR that we are cleared for }
                            { hot-key scanning }
  end else
  { Using DOS clock to update the intensities on the screen }
  if KeepIntensity and not Int_9_Active then begin
    asm
      CLI
    end;
      TSR.temp_SS := SSeg;     { Save the current stack }
      TSR.temp_SP := SPtr;
    asm;
      MOV SS,TSR.Our_SS        { Switch to our own stack! }
      MOV SP,TSR.Our_SP
    end;


    {--- LOCK INTENSITY:  START ---}

    {Replace if palette is new "different" and auto-level the palette colors}
    GetPalette(T);
    if (CompPal(T,P2) = False) and (CompPal(T,P1) = False) then begin
      for x:=0 to 255 do
        if (T[x*3] = P2[x*3]) and
           (T[x*3+1] = P2[x*3+1]) and
           (T[x*3+2] = P2[x*3+2]) then begin
          T[x*3] := P1[x*3];
          T[x*3+1] := P1[x*3+1];
          T[x*3+2] := P1[x*3+2];
        end;
      MovePal(T,P1);
      for x:=0 to 767 do P2[x] := ((P1[x]*i) shr 5)+e;  {assume e is already calculated}
    end;

    {Locking the intensity}
    VRetrace;
    SetPalette(P2);

    {---- LOCK INTENSITY:  END ----}


    asm
      mov ss,TSR.temp_SS       { Restore original stack in memory! }
      mov sp,TSR.temp_SP
      STI
    end;
  end;



  inline ($9C);  { PUSHF -- Push flags }
  TSR.O_1;  { Call old TSR using saved vector }
end;



BEGIN

  { -- Initialize our variables : Required to initialize! ---- }

  TSR.Query := $0403;   { Define flags for our handler to reply when calling }
  TSR.Reply := $1996;   { it or to check for a sub-procedure. }
  TSR.Unload := $A403;
  TSR.Unloaded := $1978;

  { -- End of Initialize our variables ---- }


  writeln('Screen Lighter v1.0  -  Designed by Animadei[T]  04/05/1996');
  writeln('   "Coded for the cheap misfortunate bad monitor owners."');
  writeln;

  i := 32;  {Initialize intensity}
  KeepIntensity := False;

  if not Check_TSR then begin
    writeln('This  program has been tested intensively,  but it is');
    writeln('still classified as in the alpha state. No warranties');
    writeln('are given.  *Use at your own risk!*');
    writeln;
    writeln('Keys:');
    writeln('        F7  - Save current palette');
    writeln('        F8  - Load saved palette');
    writeln('        F9  - Lock intensity on/off');
    writeln('              (high/low speaker sound)');
    writeln('        F10 - *Undetermined*');
    writeln('        F11 - Increase intensity');
    writeln('        F12 - Decrease intensity');
    writeln;
    Writeln('TSR loaded.');
    { Hook the interrupt and load TSR to memory }
    Load_TSR($1C,@Main);
    end else begin
      Writeln('TSR unloaded.');
      Unload_TSR;
    end;

END.

